package edu.ncsu.csc.mas.protocols.Order.Customer;

import java.io.IOException;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Logger;

import edu.ncsu.csc.mas.utils.JMSWrapper;
import edu.ncsu.csc.mas.utils.JessWrapper;

import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;
import edu.ncsu.csc.mas.protocols.Order.messages.*;


/**
 * @author Nirmit Desai
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

public class Main {
	
	private static JessWrapper jsw;	
	private static Logger logger = null;
	
	private static  final String MERCHANTQ = "jms/defaultMerchantQ";
	private static  final String CUSTOMERQ = "jms/defaultCustomerQ";
	private static  final String QCFACTORY = "jms/defaultQcf";
	private static  final String INPUT = "INPUT";
	private static  final String OUTPUT = "OUTPUT";
	
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		try{
			initLogger("/opt/log/owlp/%t/customer.log");
			
			logger.info("Logger initialized");
			logger.info("Current working directory for Customer:"+System.getProperty("user.dir"));
			
			jsw = JessWrapper.getJessWrapperInstance();
			logger.info("JessWrapper initialized");
			
			String[] queues = new String[]{MERCHANTQ, CUSTOMERQ};
			JMSWrapper.initJMSWrapper(QCFACTORY, queues);
			logger.info("JMSWrapper initialized");
			
			//Initialize Jess
			jsw.executeCommand("(batch commitments.clp)");
			jsw.executeCommand("(batch customer.clp)");
			jsw.executeCommand("(batch customerPolicies.clp)");
			logger.info("Jess rule system initialized");
			
			// Kick-off the protocol
			start st = new start(6481);
			JMSWrapper.sendTo(CUSTOMERQ,st);
			logger.info("Customer agent kicked-off");
			
			while(true)
			{
				JJMessage msg = JMSWrapper.blockingReceiveFrom(CUSTOMERQ);
				logger.info("Customer received:"+msg.getType());
				String type = msg.getType();
				jsw.store(INPUT, msg);
				jsw.executeCommand("(definstance " +type+ "Msg (fetch INPUT) static)");
				logger.info("Customer stored:"+msg.getType()+ " to KB");
				jsw.executeCommand("(run)");				
				
				JJMessage send = (JJMessage)jsw.fetch(OUTPUT);
				if(send!=null)
				{
					JMSWrapper.sendTo(MERCHANTQ,send);
					logger.info("Customer sending:"+send.getType()+ " to Merchant");
				}
			}
			
		}catch(Exception e){
			e.printStackTrace();
			logger.info(e.getMessage());
		}
		
	}

	private static void initLogger(String filePath) throws IOException
	{
		Handler fh = new FileHandler(filePath);
		logger = Logger.getLogger("");
		logger.addHandler(fh);		
	}
	
	/* (non-Java-doc)
	 * @see java.lang.Object#Object()
	 */
	public Main() {
		super();
	}

}

