(import edu.ncsu.csc.mas.netbill.messages.*)
(import edu.ncsu.csc.mas.netbill.*)
(defclass start Start)
(defclass finish Finish)
(defclass offer Offer extends msg)
(defclass accept Accept extends msg)
(defclass rfq RequestForQuotes extends msg)
(defclass goods Goods extends msg)
(defclass pay Payment extends msg)
(defclass receipt Receipt extends msg)


(defrule send-request 
	(and (start) (out-of-stock ?x))
	=> 
	;;Create a RFQ message
	(bind ?rfq-var (new RequestForQuotes ?x 1))
	(definstance rfq ?rfq-var static)
	(store OUTPUT ?rfq-var))
	;(printout t "RFQ sent is" ?rfq-var crlf))
	   
(defrule send-accept
	 (and (offer (m_nTransID ?t) (m_szQuoteFor ?x)(m_szPrice ?y)) (accept-offer ?x ?y))
         => 
	;;;;;;;;;;;;;;;;;;; Create the conditional commitment "goods if accept"
	(bind ?cc-var (new ConditionalCommitment "merchant" "customer" "ACCEPT" "GOODS" ?t))
	(definstance ccom ?cc-var static)
	;;;;;;;;;;;;;;;;;;;Create the accept message
	(bind ?accept-var (new Accept ?t))
	(definstance accept ?accept-var static)
	(store OUTPUT ?accept-var)
	;;;;;;;;;;;;;;;;;;; Create the conditional commitment "pay if goods"
	(bind ?cc-var (new ConditionalCommitment "customer" "merchant" "GOODS" "PAYMENT" ?t))
	(definstance ccom ?cc-var static))
	;(printout t "ACCEPT sent is" ?accept-var crlf))


(defrule send-payment
	 (and (goods (m_nTransID ?t)) (offer (m_nTransID ?t)(m_szPrice ?p)))
	  => 
	 ;;;;;;;;;;;;;;;;; Create the conditional commitment "receipt if pay"
	(bind ?cc-var (new ConditionalCommitment "merchant" "customer" "PAYMENT" "RECEIPT" ?t))
	(definstance ccom ?cc-var static)
	;;;;;;;;;;;;;;;;;; Now create the payment message
	(bind ?payment-var (new Payment ?p ?t))
	(definstance pay ?payment-var static)
	(store OUTPUT ?payment-var))
	;(printout t "Payment sent is" ?payment-var crlf))

		    
(defrule send-finish
	 (receipt) 
	=> 
	;;;;;;;;;;;;;;;;; Finish the Protocol
	(bind ?finish-var (new Finish))
	(definstance finish ?finish-var static)
	(store OUTPUT ?finish-var))
	;(printout t "Protocol Finished" crlf))


		    
