/*
 * Created on Oct 20, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;


/**
 * Represents an OWL-P construct.
 * 
 * OwlpObject represents an element of the OWL-P ontolog. Elements are
 * commitments, conditional commitments, knowledge base, messages, 
 * propositions, and roles.
 * 
 * @author aumallya
 *
 */
public class OwlpObject {
    
	public String getOntClassFromOwlpObject()
	{
		
		if (this instanceof Proposition)
			return "Proposition";

		else if (this instanceof Commitment)
			return "Commitment";
		else if (this instanceof Message)
			return "Message";
		else if (this instanceof KnowledgeBase)
			return "KnowledgeBase";
		else if (this instanceof Role)
			return "Role";
		else if (this instanceof Protocol)
			return "Protocol";
		
	else return null;
}
}
