package edu.ncsu.csc.mas.utils;

import java.util.HashMap;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import javax.jms.ObjectMessage;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueConnection;
import javax.jms.QueueSession;
import javax.jms.QueueSender;
import javax.jms.QueueReceiver;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.JMSException;

import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;


public class JMSWrapper {
	
	private static QueueConnectionFactory qcf = null;
	private static QueueSession session = null;
	private static HashMap queues = new HashMap();
	private static JMSWrapper jmw = null;
	
	public static void initJMSWrapper(String factoryJNDI, String[] agentJNDIs) 
	throws NamingException, JMSException
	{
		Hashtable env= new Hashtable();
		env.put(Context.INITIAL_CONTEXT_FACTORY,"com.ibm.websphere.naming.WsnInitialContextFactory");
		env.put(Context.PROVIDER_URL,"corbaloc:iiop:bombadil.csc.ncsu.edu:2809");
		
		InitialContext context = new InitialContext(env);		
		
		//System.out.println("context looked up:"+context.lookup(factoryJNDI));
		qcf  = (QueueConnectionFactory)PortableRemoteObject.narrow(context.lookup(factoryJNDI),javax.jms.QueueConnectionFactory.class);		
		QueueConnection conn = qcf.createQueueConnection();		
		conn.start();
		session = conn.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
		
		for(int i=0;i<agentJNDIs.length;i++)
		{
			//System.out.println("context looking:"+context.lookup(agentJNDIs[i]));
			Queue q = (Queue) context.lookup(agentJNDIs[i]);	
			queues.put(agentJNDIs[i], q);
		}
	}

	
	public static void sendTo(String queueJNDI, JJMessage msg) throws JMSException
	{
		QueueSender sender = session.createSender((Queue)queues.get(queueJNDI));
		ObjectMessage om = session.createObjectMessage(msg);
		//System.out.println("Customer prepared:"+om);
		sender.send(om);
		sender.close();
	}
	
	public static JJMessage blockingReceiveFrom(String queueJNDI) throws JMSException
	{
		QueueReceiver receiver = session.createReceiver((Queue)queues.get(queueJNDI));
		ObjectMessage om = (ObjectMessage)receiver.receive();
		//System.out.println("Customer sees:"+om);
		receiver.close();
		return (JJMessage)om.getObject();
	}
}
