/*
 * Created on May 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package edu.ncsu.csc.mas.utils;

import jess.*;

/**
 * @author amitc
 * 
 * Wraps the Rete engine
 */
public class JessWrapper {
	
	Rete m_Engine;	
	
	private static JessWrapper jw=null;
	
	/**
	 * Constructor: creates a new instance of the Rete engine and initializes it
	 *
	 */
	private JessWrapper() {
		m_Engine = new Rete();
		try {
			m_Engine.clear();
			m_Engine.reset();
		} catch(JessException ex){
			ex.printStackTrace();
		}
	}
	
	/* 
	 * Factory method for getting an instance of jess wrapper.
	 */
	public static JessWrapper getJessWrapperInstance()
	{
		if(jw==null)
		{
			jw = new JessWrapper();
			return jw;
		}
		else
			return jw;
	}
	
	/**
	 * Executes the command in the Jess engine
	 * @param command: A Jess command
	 */
	
	public void executeCommand(String command) {
		try {
			Value val = m_Engine.executeCommand(command);
			System.out.println(val.toString());
		} 
		catch(JessException ex) {
				ex.printStackTrace();
		}
	}
	
	
	public void createJessStringVar(String name, String value) {
		try {
			Value val = new Value(value, RU.STRING);
			m_Engine.getGlobalContext().setVariable(name, val);
		} 
		catch (JessException ex) {
			ex.printStackTrace();
		}
		
	}
	
	
	public void store(String hash, Object obj) {
		m_Engine.store(hash, obj);
	}
	
	public Object fetch(String hash) {
		Value val = m_Engine.fetch(hash);
		try {
			return val.externalAddressValue(m_Engine.getGlobalContext());
		} 
		catch(JessException ex) {
			ex.printStackTrace();
			return null;
		}
		
		
	}
}

	
