/*
 * Created on Jun 25, 2004
 *
 */
package edu.ncsu.csc.mas.utils;

//import com.hp.hpl.jena.rdf.model.*;
//import com.hp.hpl.jena.ontology.* ;
//import com.hp.hpl.jena.util.iterator.*;
import java.io.*;
import java.util.* ;

import edu.ncsu.csc.mas.ontology.Protocol;
import edu.ncsu.csc.mas.ontology.Role;
import edu.ncsu.csc.mas.ontology.Rule;
import edu.ncsu.csc.mas.ontology.exceptions.*;
//import edu.ncsu.csc.mas.ontology.Constants;


/**
 * @author aumallya
 *
 */
public class Owlp2Jess {
    
    public static void main(String arguments[]) 
    throws MalformedConditionException,IOException
    {
        OwlpGenerator oF = OwlpGenerator.getOwlpGenerator() ;
        Protocol prot = oF.generateProtocol() ;
        System.out.print(prot.toString()) ;
        SkeletonGenerator skelGen = new SkeletonGenerator() ;
     
        FileWriter protocolRules = new FileWriter(prot.getInstName()+ ".clp");
        BufferedWriter out1 = new BufferedWriter(protocolRules);
   
        for(int i=0;i<prot.getRules().size();i++)
        {
        	out1.write(prot.getRules().elementAt(i).toString());
        }
        out1.close();
        
        if(prot.getRoles()!=null) {
            for(int i=0; i< prot.getRoles().size(); i++) {
            	Role role = (Role)(prot.getRoles().elementAt(i));
            	String clpFileName = role.getName() + ".clp";
            	String policyClpFileName = role.getName()+"Policies.clp";
        		FileWriter clpFile = new FileWriter(clpFileName);
        		BufferedWriter out2 = new BufferedWriter(clpFile);
        		FileWriter policyClpFile = new FileWriter(policyClpFileName);
        		BufferedWriter out3 = new BufferedWriter(policyClpFile);
               	 Vector ruleVec = skelGen.generateSkeleton(prot,role) ;         
                if(ruleVec==null)
                    continue;
                prot.setSkelRules(ruleVec, (Role)(prot.getRoles().elementAt(i))) ;
                for(int j=0; j<ruleVec.size(); j++) {
                	                
                    Rule rule = (Rule)role.getSkelRules().elementAt(j);
                    System.out.println("Printing rule for role "+ role + ": " + rule.toString());
                    out2.write(rule.toString());
                    out3.write(rule.generatePolicy());
                    
                    
                }
                out2.close();
                out3.close();
            }
        }
    }

}
