(import edu.ncsu.csc.mas.protocols.OrderWithReminders.messages.*)
(import edu.ncsu.csc.mas.enactments.JessJ2EE.*)
(import edu.ncsu.csc.mas.protocols.OrderWithReminders.customer.*)
(import edu.ncsu.csc.mas.utils.JMSWrapper)
(defclass startPropMsg startProp extends msg)
(defclass rejectQuote rejectQuote extends msg)
(defclass rejectQuoteMsg rejectQuote extends msg)
(defclass rejectQuoteMsgProp rejectQuote extends msg)
(defclass reqForQuote reqForQuote extends msg)
(defclass reqForQuoteMsg reqForQuote extends msg)
(defclass reqForQuoteMsgProp reqForQuote extends msg)
(defclass reminder reminder extends msg)
(defclass reminderMsg reminder extends msg)
(defclass reminderMsgProp reminder extends msg)
(defclass acceptQuote acceptQuote extends msg)
(defclass acceptQuoteMsg acceptQuote extends msg)
(defclass acceptQuoteMsgProp acceptQuote extends msg)
(defclass quote quote extends msg)
(defclass quoteMsg quote extends msg)
(defclass quoteMsgProp quote extends msg)
(deftemplate remindAbout (slot itemID)(slot itemPrice))
(deftemplate composition_itemID_prop (slot itemID))
(deftemplate composition_itemPrice_prop (slot itemPrice))
(deftemplate rejectQuote_Policy)
(deftemplate reqForQuote_Policy (slot itemID))
(deftemplate reminder_Policy)
(deftemplate acceptQuote_Policy)
(deftemplate quote_Policy)
(defclass customerOrderWithRemindersPolicy customerOrderWithRemindersPolicy)

(defrule rejectQuoteRule_for_customer
(and (quoteMsgProp (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) (rejectQuote_Policy))
=>	 (bind ?rejectQuote-var (new rejectQuote ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance rejectQuoteMsgProp ?rejectQuote-var static)
	(store OUTPUT ?rejectQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/merchantQ")))

(defrule reqForQuoteRule_for_customer
(and (startPropMsg (transID ?t1)) (reqForQuote_Policy (itemID ?itemID-var1) ))
=>	 (bind ?reqForQuote-var (new reqForQuote ?itemID-var1 ?t1))
	(definstance reqForQuoteMsgProp ?reqForQuote-var static)
	(assert (composition_itemID_prop (itemID ?itemID-var1)))
	(store OUTPUT ?reqForQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/merchantQ")))

(defrule composition_quoteProp_rule
(and (quoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) (composition_itemID_prop(itemID ?itemID-var2)) (composition_itemPrice_prop(itemPrice ?itemPrice-var2)))
=>	 (assert (remindAbout (itemID ?itemID-var2) (itemPrice ?itemPrice-var2))))

(defrule composition_acceptQuoteProp_rule
(acceptQuoteMsgProp  (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) 
=>	 (assert (positiveDecision)))

(defrule composition_rejectQuoteProp_rule
(rejectQuoteMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) 
=>	 (assert (negativeDecision)))

(defrule reminderRule_for_customer
(and (remindAbout (itemID ?itemID-var2) (itemPrice ?itemPrice-var2)) (not (positiveDecision)) (not (negativeDecision)) (reminderMsg (itemID ?itemID-var1) (itemPrice itemPrice-var1) (transID ?t6)) (reminder_Policy))
=>	 (bind ?reminder-var (new reminder ?itemID-var1 ?itemPrice-var1 ?t6))
	(definstance reminderMsgProp ?reminder-var static))

(defrule acceptQuoteRule_for_customer
(and (quoteMsgProp (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) (acceptQuote_Policy))
=>	 (bind ?cc-var(new JJConditionalCommitment "customer"   "merchant"   "goods" "pay" ?t1))
	 (definstance ccom ?cc-var static)(bind ?acceptQuote-var (new acceptQuote ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance acceptQuoteMsgProp ?acceptQuote-var static)
	(store OUTPUT ?acceptQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/OrderWithReminders/merchantQ")))

(defrule quoteRule_for_customer
(and (reqForQuoteMsgProp  (itemID ?itemID-var1)(transID ?t1)) (quoteMsg (itemID ?itemID-var2) (itemPrice ?itemPrice-var2)(transID ?t2)) (quote_Policy))
=>	 (bind ?cc-var(new JJConditionalCommitment "merchant"   "customer"   "pay" "goods" ?t2))
	 (definstance ccom ?cc-var static)(bind ?quote-var (new quote ?itemID-var2 ?itemPrice-var2 ?t2))
	(definstance quoteMsgProp ?quote-var static)
	(assert (composition_itemPrice_prop (itemPrice ?itemPrice-var2))))