/*
 * Created on Jun 22, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;

import java.util.Vector;  
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.ontology.* ;



/**
 * Represents an action as specified by OWL-P. 
 * 
 * <a href="http://bombadil.csc.ncsu.edu/owl/v3_6/Protocol.owl">OWL-P</a> specifies 
 * pre-conditions and effects of a message. Each effect is an action. When a
 * message is received, all the specified effects must occur, i.e., all actions must be 
 * performed. An action can be to:<p>
 * 1) Add a proposition to the current state (states are sets of propositions that hold).<p>  
 * 2) Send a message.<p>
 * 3) Verify that a message has been received.<p>
 * 4) Create a (base-level or conditional) commitment. 
 *
 * @author Ashok Mallya
 * 
 */
public abstract class Action {

    /**
     * Return an easy-to-read string describing this action.
     * 
     * The return value should contain the type of action and the entities that this action
     * is performed on.
     * 
     * @return A string representing this action
     */
    public abstract String toString() ;
}
