/*
 * Created on Jun 22, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;

import com.hp.hpl.jena.ontology.* ;
import com.hp.hpl.jena.rdf.model.*;
import java.util.Vector ;

/**
 * @author aumallya, pchakra
 *
 */
public class Role extends OwlpObject{
    private String name ;
    private Vector skelRules ;
    private OntResource ontRes;

    
    StmtIterator sIter ;
    
    public Role(OntResource res) {
        this.name = new String(res.getLocalName()) ;
        this.ontRes =res;
    }
    
    public Role(String n) {
        name = new String(n) ;
    }
    
    public Role() {
        super() ;
    }
    
    public Role(Role r) {
        this.name = new String(r.getName()) ;
        this.ontRes = r.getOntResource();
    }
    
    public String toString() {
        return name ;
    }
    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * @return Returns the skelRules.
     */
    public Vector getSkelRules() {
    	
        return skelRules;
    }
    /**
     * @param skelRules The skelRules to set.
     */
    public void setSkelRules(Vector skelRules) {
        this.skelRules = skelRules;
    }
    
    public void addToSkelRules(Rule r) {
        if(this.skelRules == null)
            this.skelRules = new Vector() ;
        this.skelRules.add(r) ;
    }
    
    
    public boolean equals(Role r) {
        if(r==null || this.name==null)
            return false ;
        else if(r.name == this.name)
            return true;

        return false ;
    }
    
    public OntResource getOntResource()
    {
    	return this.ontRes;
    }
    
  }
