/*
 * Created on Jun 23, 2004
 *
 */
package edu.ncsu.csc.mas.utils;


/**
 * Some constants used in this package. 
 * Most importantly, location of the OWL ontology of protocols.
 * 
 * @author Ashok Mallya
 *
 */
public class Constants {

		/*
		 * Enactment constants
		 */
		public final static String OUTPUT="OUTPUT";
		public final static String INPUT="INPUT";
    	
		/**
    	 * Output information during execition if <code>true</true>
    	 */
    	public static boolean DEBUG = true ;
    	
    	public static boolean VIEW_PROTOCOL_STATEMENTS = false ;
    	
    	/**
    	 * Separator between file location and tag name in XML
    	 */
    	public static String hash = "#" ;
    	public static String OntologyFileLocation = "http://www4.ncsu.edu/~nvdesai/owl/Protocol.owl" ;
    	public static String InstanceFileLocation = "http://www4.ncsu.edu/~nvdesai/owl/Shipping.owl" ;
    	public static String RDFSyntaxLocation = "http://www.w3.org/1999/02/22-rdf-syntax-ns" ;
    	public static String SWRLLocation = "http://www.w3.org/2003/11/swrl" ;
    	
    	/**
    	 * The string that represents the property relating a protocol to the 
    	 * messages it defines
    	 */
    	public static String PROTOCOL_MESSAGE_PROPERTY_NAME = "involvesMessage" ;
    	
    	/**
    	 * The string that represents the property relating a protocol to the 
    	 * roles it defines
    	 */
    	public static String PROTOCOL_ROLE_PROPERTY_NAME = "hasRole" ;
    	
    	/**
    	 * The string that represents the property relating a protocol to the 
    	 * knowledge base it uses
    	 */
    	public static String PROTOCOL_KNOWLEDGEBASE_PROPERTY_NAME = "consults" ;
    	
    	/**
    	 * The string that represents the property relating a protocol to the 
    	 * composition profile that defines it
    	 */
    	public static String PROTOCOL_COMPOSITION_PROFILE_PROPERTY_NAME = "definedBy" ;
    	
    	/**
    	 * The string that represents the property relating a protocol to the 
    	 * rules it defines
    	 */
    	public static String PROTOCOL_RULE_PROPERTY_NAME 		= "dictatesRule" ;
    	public static String MESSAGE_SENDER_PROPERTY_NAME 		= "hasSender" ;
    	public static String MESSAGE_RECEIVER_PROPERTY_NAME 	= "hasReceiver" ;
    	public static String MESSAGE_PARAMETER_PROPERTY_NAME 	= "hasParameter" ;
    	public static String PROP_SLOT_PROPERTY_NAME			= "hasSlot" ;
    	public static String PROTOCOL_CLASS_NAME	= "Protocol" ;
    	public static String ROLE_CLASS_NAME 		= "Role" ;
    	public static String MESSAGE_CLASS_NAME		= "Message" ;
    	public static String RULE_CLASS_NAME		= "Rule" ;
    	public static String KB_CLASS_NAME			= "KnowledgeBase" ;
    	public static String PROPOSITION            = "Proposition";

    	public static int BODY = 10 ;
    	public static int HEAD = 11 ;
}
