package edu.ncsu.csc.mas.utils;

import java.util.HashMap;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

import javax.jms.ObjectMessage;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueConnection;
import javax.jms.QueueSession;
import javax.jms.QueueSender;
import javax.jms.QueueReceiver;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.JMSException;

import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;


public class JMSWrapper {
	
	private static QueueConnectionFactory qcf = null;	
	private static HashMap queues = new HashMap();
	private static JMSWrapper jmw = null;
	private static JessWrapper jsw = JessWrapper.getJessWrapperInstance();
	
	public static void initJMSWrapper(String factoryJNDI, String[] agentJNDIs) 
	throws NamingException, JMSException
	{
		Hashtable env= new Hashtable();
		env.put(Context.INITIAL_CONTEXT_FACTORY,"com.ibm.websphere.naming.WsnInitialContextFactory");
		env.put(Context.PROVIDER_URL,"corbaloc:iiop:127.0.0.1:2809");
		
		InitialContext context = new InitialContext(env);		
		
		//System.out.println("context looked up:"+context.lookup(factoryJNDI));
		qcf  = (QueueConnectionFactory)PortableRemoteObject.narrow(context.lookup(factoryJNDI),javax.jms.QueueConnectionFactory.class);	
				
		for(int i=0;i<agentJNDIs.length;i++)
		{
			//System.out.println("context looking:"+context.lookup(agentJNDIs[i]));
			Queue q = (Queue) context.lookup(agentJNDIs[i]);			
			queues.put(agentJNDIs[i], q);
		}
	}

	/* deprecated: for backward compatibility */
	public static void sendTo(String queueJNDI, JJMessage msg) throws JMSException
	{
		QueueConnection conn = qcf.createQueueConnection();			
		conn.start();
		QueueSession session = conn.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
		QueueSender sender = session.createSender((Queue)queues.get(queueJNDI));
		ObjectMessage om = session.createObjectMessage(msg);	
		sender.send(om);
		sender.close();
		session.close();
		conn.close();
	}
	
	/* called from Jess engine */
	synchronized public static void sendTo(String queueJNDI) throws JMSException
	{
		JJMessage msg = (JJMessage)jsw.fetch(Constants.OUTPUT);
		QueueConnection conn = qcf.createQueueConnection();			
		conn.start();
		QueueSession session = conn.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
		QueueSender sender = session.createSender((Queue)queues.get(queueJNDI));
		ObjectMessage om = session.createObjectMessage(msg);		
		sender.send(om);
		sender.close();
		session.close();
		conn.close();		
	}
	
	public static JJMessage blockingReceiveFrom(String queueJNDI) throws JMSException
	{
		QueueConnection conn = qcf.createQueueConnection();			
		conn.start();
		QueueSession session = conn.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
		QueueReceiver receiver = session.createReceiver((Queue)queues.get(queueJNDI));
		ObjectMessage om = (ObjectMessage)receiver.receive();
		
		receiver.close();
		session.close();
		conn.close();
		return (JJMessage)om.getObject();
	}
}
